-- change these values to change appearance of edge effect
local FADE_DURATION = 0.2 -- time (in seconds) for fadein/fadeout
local TEXTURE_PATH = "Interface\\FullScreenTextures\\LowHealth" -- texture of edge effect
local ALPHA_MODE = "ADD" -- aka blend mode: wowpedia.fandom.com/wiki/UITYPE_AlphaMode
local R,G,B = 1,1,1 -- red,green,blue (0 to 1 each) of edge effect
local DESATURATE = true -- whether R,G,B should be applied to a greyscale of the texture
local MAX_ALPHA = 1 -- 0 to 1 transparency of edge effect
local FRAME_STRATA = "BACKGROUND" -- frame strata of edge effect

-- visible frame
local f = CreateFrame("Frame","StealthEdgeEffect",UIParent)
f:SetAllPoints(true)
f:SetFrameStrata(FRAME_STRATA)
f:SetAlpha(MAX_ALPHA)
f:Hide()

f.texture = f:CreateTexture(nil,"BACKGROUND")
f.texture:SetAllPoints(true)
f.texture:SetTexture(TEXTURE_PATH)
f.texture:SetBlendMode(ALPHA_MODE)
f.texture:SetDesaturated(DESATURATE)
f.texture:SetVertexColor(R,G,B)

f.fadein = f:CreateAnimationGroup()
f.fadein.anim = f.fadein:CreateAnimation("alpha")
f.fadein.anim:SetFromAlpha(0)
f.fadein.anim:SetToAlpha(MAX_ALPHA)
f.fadein.anim:SetDuration(FADE_DURATION)
f.fadein:SetScript("OnPlay",function(self) self:GetParent().fadeout:Stop() self:GetParent():Show() end)

f.fadeout = f:CreateAnimationGroup()
f.fadeout.anim = f.fadeout:CreateAnimation("alpha")
f.fadeout.anim:SetFromAlpha(MAX_ALPHA)
f.fadeout.anim:SetToAlpha(0)
f.fadeout.anim:SetDuration(FADE_DURATION)
f.fadeout:SetScript("OnFinished",function(self) self:GetParent().fadein:Stop() self:GetParent():Hide() end)

-- state driver
local s = CreateFrame("Frame",nil,nil,"SecureHandlerStateTemplate")

s:SetScript('OnAttributeChanged', function(self, name, value)
    if name=='state-isstealthed' and f[value] then
        f[value]:Play()
    end
end)

RegisterStateDriver(s, 'isstealthed', '[stealth] fadein; fadeout')
